local vehicleDisplay

local M = {}

local function showInfo()
	guihooks.trigger('ScenarioFlashMessageReset')
	guihooks.trigger('ScenarioFlashMessage', {
		{ vehicleDisplay, 2, false }
	})
end

local function onRaceStart()
	local infoTimer = bnse.timers.create(1, { onEnd = showInfo })
	infoTimer:start()
end

local function onScenarioChange(scenario)
	local perfClass = 0
	-- Check scenario state and the headlights state
	if scenario and scenario.state == 'pre-start' and (Gh05t_jump_lights == nil or Gh05t_jump_lights == 0) then
		local config = bnse.randomize.vehicle('scenario_player0')
		perfClass = tonumber(config['Performance Class'])
		while( perfClass == nil or perfClass < 8 )
		do
			--print(string.format('Original vehicle: %s, perfClass: %s', config.Name, config['Performance Class']))
			config = bnse.randomize.vehicle('scenario_player0')
			perfClass = tonumber(config['Performance Class'])
		end
		vehicleDisplay = string.format('Vehicle: %s, PerfClass: %s', config.Name, config['Performance Class'])
		print(vehicleDisplay)
	end
end

local function onPhysicsEngineEvent(eventType)
	-- Freeze whenever a vehicle is spawned or despawned
	if eventType == 'spawn' or eventType == 'despawn' then
		scenetree.scenario_player0:queueLuaCommand('scenario.freeze(1)')
	end
end

local function onRaceTick(raceTickTime)
	local lveh = Lua:getControlVehicle()
    if lveh == nil then print("no vehicle got") end
	-- 'Ping Pong' between vehicle lua and beam engine lua to set global variable in beam engine lua
	lveh:queueLuaCommand("obj:queueGameEngineLua ('Gh05t_jump_lights = ('..electrics.values['lowhighbeam']..')')")
end

M.onPhysicsEngineEvent = onPhysicsEngineEvent
M.onScenarioChange = onScenarioChange
M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick

return M